<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: articles.php
| Author: Nick Jones (Digitanium)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

/*******************************************************
	SEO4All
	Version: 20100906
	Author: Igor Ferreira Cemim (aka Splash)
	Web: http://igor.cz.cc
*******************************************************/

//	Ativar (true) ou desativar (false) o MOD.
$enabled = true;
$cyrillic = "Ũ";
$accents = "";
$basic = "a-zA-Z0-9";
$pontuation = "!?;.,.\/ ";
$others = "-";
$newTitle = false;

function main ()
{
	global $enabled, $accents, $basic, $pontuation, $others, $newTitle, $cyrillic;
	//	A condio iADMIN == false  usada para detectar se o usurio  administrador, e consequentemente
	//	impedir o corrompimento dos links da rea administrativa.
	if ($enabled == false and iADMIN == false) {
		//	Meus crditos ;)
		add_to_head("<!--\nFriendly URLs by SEO4All\nAuthor: Igor Ferreira Cemim (aka Splash)\nWeb: http://igor.cz.cc/\n-->");

		//	Inverte o ttulo da pgina ^^
		//	De: Esttico - Dinmico - Dinmico			Para: Dinmico - Dinmico - Esttico
		replace_in_output("\<title\>([$accents$basic$pontuation]+) - ([$accents$basic$pontuation]+)\<\/title\>", "<title>$2 - $1</title>");
		replace_in_output("\<title\>([$accents$basic$pontuation]+) - ([$accents$basic$pontuation]+)([:]) ([$accents$basic$pontuation$others]+)\<\/title\>", "<title>$4 - $2 - $1</title>");

		if (iADMIN == false) {
			if (stristr(PHP_OS, 'WIN')) {
				//	Para servidores Windows
				$cwd = str_replace("\\", "/", getcwd());
				$self = str_replace($_SERVER['DOCUMENT_ROOT'], "", $cwd);
			} else {
				//	Para servidores Linux
				$self = explode("/", $_SERVER['PHP_SELF']);
				array_pop($self);
				$self = implode("/", $self);
			}
			replace_in_output("\<head\>", "<head>\r\n<base href=\'http://" . $_SERVER['SERVER_NAME'] . $self  . "/\' />");
		}


		//	Link in news title
		replace_in_output("\<a name=\'news_([0-9]+)\' id=\'news_([0-9]+)\'\>\<\/a\>([$accents$basic$pontuation$others$cyrillic]+)", "<a name=\'news_$1\' id=\'news_$2\'></a><a href=\'news.php?readmore=$2\'>$3</a>");

		//	Substitui:											Por:
		//	news.php?readmore=123456							noticia/ola-mundo/123456
		//	news.php?readmore=123456#comments					noticia/ola-mundo/123456#comments
		replace("news\.php\?readmore=([0-9]+)(#comments)?", "news($1, \"$2\")", "e");

		//	Substitui:											Por:
		//	articles.php?article_id=123456						artigo/ola-mundo/123456
		replace("articles\.php\?article_id=([0-9]+)", "article($1)", "e");

		//	Substitui:											Por:
		//	downloads.php?cat_id=123456&download_id=123456		download/ola-mundo/123456
		replace("downloads\.php\?cat_id=([0-9]+)&amp;download_id=([0-9]+)", "download($2)", "e");

		//	Substitui:											Por:
		//	downloads.php?cat_id=123456							categorias/downloads/ola-mundo/123456
		replace("downloads\.php\?cat_id=([0-9]+)", "downloadsCategories($1)", "e");

		//	Substitui:											Por:
		//	articles.php?cat_id=123456							categorias/artigos/ola-mundo/123456
		replace("articles\.php\?cat_id=([0-9]+)", "articlesCategories($1)", "e");

		//	Substitui:											Por:
		//	news_cats.php?cat_id=123456							categorias/noticias/ola-mundo/123456
		replace("news_cats\.php\?cat_id=([0-9]+)", "newsCategories($1)", "e");

		//	Substitui:											Por:
		//	profile.php?lookup=123456							perfil/ola-mundo/123456
		replace("profile\.php\?lookup=([0-9]+)", "profile($1)", "e");

		//	Substitui:											Por:
		//	print.php?type=N&amp;item_id=123456					imprimir/noticia/ola-mundo/123456
		replace("print\.php\?type=N\&amp;item_id=([0-9]+)", "printNews($1)", "e");

		//	Substitui:											Por:
		//	viewforum.php?forum_id=123456						secao/ola-mundo/123456
		replace("viewforum\.php\?forum_id=([0-9]+)", "forum(\'$1\')", "e");

		//	Substitui:											Por:
		//	viewthread.php?thread_id=123456						topico/ola-mundo/123456
		replace("viewthread\.php\?thread_id=([0-9]+)", "thread(\'$1\')", "e");

		//	Substitui:											Por:
		//	viewpage.php?thread_id=123456						pagina/ola-mundo/123456
		replace("viewpage\.php\?page_id=([0-9]+)", "customPage(\'$1\')", "e");

		//	Substitui:											Por:
		//	faq.php?cat_id=123456								faq/ola-mundo/123456
		replace("faq\.php\?cat_id=([0-9]+)", "faq(\'$1\')", "e");

		//	Substitui:											Por:
		//	weblinks.php?cat_id=123456&weblink_id=123456		weblink/ola-mundo/123456
		replace("weblinks\.php\?cat_id=([0-9]+)\&amp;weblink_id=([0-9]+)", "weblink($2)", "e");

		//	Substitui:											Por:
		//	weblinks.php?cat_id=123456							categorias/weblinks/ola-mundo/123456
		replace("weblinks\.php\?cat_id=([0-9]+)", "weblinksCategories(\'$1\')", "e");

		replace("forum\/index\.php", "forum/main.html");
		replace("news\.php", "news.html");
		replace("login\.php", "login.html");
		replace("index\.php", "main.html");
		replace("articles\.php", "categories/articles.html");
		replace("downloads\.php", "categories/downloads.html");
		replace("news_cats\.php", "categories/news.html");
		replace("weblinks\.php", "categories/weblinks.html");
		replace("faq\.php", "categories/faqs.html");
		replace("contact\.php", "contact.html");
		replace("photogallery\.php", "photo-gallery.html");
		replace("search\.php", "search.html");
		replace("setuser\.php\?logout=yes", "logout.html");
		replace("members\.php", "member-list.html");
		replace("messages\.php", "private-messages.html");
		replace("edit_profile\.php", "edit-profile.html");
		replace("register\.php", "register.html");
		replace("lostpassword\.php", "lost-password.html");
		replace("submit\.php\?stype=l", "send-link.html");
		replace("submit\.php\?stype=n", "send-news.html");
		replace("submit\.php\?stype=a", "send-article.html");
		replace("submit\.php\?stype=p", "send-photo.html");

		//	Evita erros de redirecionamento aps o envio do formulrio de login.
		replace_in_output("name=\'loginform\' method=\'post\' action=\'categories/([a-zA-Z0-9]+)\'", "name=\'loginform\' method=\'post\' action=\'" . BASEDIR . "main\'");
	}
}

function title ($n1, $n2, $n3 = "", $n4 = "")
{
	global $newTitle;
	$newTitle = true;

	if ($n1 != "" and $n2 != "" and $n3 != "" and $n4 != "") {
		return "<title>$n4 - $n2 - $n1";
	} else {
		return "<title>$n2 - $n1";
	}
}

function replace ($re, $replace, $modifiers = "")
{
	//	Os prefixos utilizados nessa funo impedem que palavras e links externos sejam substitudos.
	//	Somente links internos devem ser substitudos. =D
	if ($modifiers == "") {
		return replace_in_output("\'".str_replace(array("/", "."), array("\\/", "\."), BASEDIR).$re."\'", "\'".BASEDIR.$replace."\'");
	} else {
		return replace_in_output($re, $replace, $modifiers);
	}
}

function slug($string)
{
	$string = strtolower($string);
	$cyrylicFrom = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');
        $cyrylicTo   = array('A', 'B', 'V', 'G', 'D', 'E', 'Yo', 'Zh', 'Z', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'R', 'S', 'T', 'U', 'F', 'H', 'C', 'Ch', 'Sh', 'Shtch', 'i', 'I', 'i', 'E', 'Yu', 'Ya', 'a', 'b', 'v', 'g', 'd', 'e', 'yo', 'z', 'z', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'f', 'h', 'c', 'ch', 'sh', 'shtch', 'i', 'i', 'i', 'e', 'yu', 'ya');
        $string = str_replace($cyrylicFrom, $cyrylicTo, $string);
	$special = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '', '');
	$normal = array('a', 'a', 'a', 'a', 'a', 'e', 'e', 'e', 'e', 'i', 'i', 'i', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'c');
	$string =  str_replace($special, $normal, $string);

	return preg_replace(array('/[^a-zA-Z0-9 -]/', '/[ -]+/', '/^-|-$/'), array('', '-', ''), $string); 
}

function customPage ($id)
{
	$result = dbquery("SELECT page_title FROM " . DB_CUSTOM_PAGES . " WHERE page_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'page/' . $title . '/' . $id . '.html';
}

function forum($id)
{
	$result = dbquery("SELECT forum_name FROM " . DB_FORUMS . " WHERE forum_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'section/' . $title . '/' . $id . '.html';
}

function thread($id)
{
	$result = dbquery("SELECT thread_subject FROM " . DB_THREADS . " WHERE thread_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'topic/' . $title . '/' . $id . '.html';
}

function news ($id, $comments = "")
{
	$result = dbquery("SELECT news_subject FROM " . DB_NEWS . " WHERE news_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'news/' . $title . '/' . $id . $comments . '.html';
}

function article ($id)
{
	$result = dbquery("SELECT article_subject FROM " . DB_ARTICLES . " WHERE article_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'article/' . $title . '/' . $id . '.html';
}

function download ($id)
{
	$result = dbquery("SELECT download_title FROM " . DB_DOWNLOADS . " WHERE download_id = " . $id);
	$title = slug(dbresult($result, 0));

	//	O PHP-Fusion no usa o primeiro parametro.
	//	return 'download/' . $title . '/' . $id . '/' . $id2;
	return 'download/' . $title . '/' . $id . '.html';
}

function faq ($id)
{
	$result = dbquery("SELECT faq_cat_name FROM " . DB_FAQ_CATS . " WHERE faq_cat_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'faq/' . $title . '/' . $id . '.html';
}

function weblink ($id)
{
	$result = dbquery("SELECT weblink_name FROM " . DB_WEBLINKS . " WHERE weblink_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'weblink/' . $title . '/' . $id . '.html';
}

function weblinksCategories ($id)
{
	$result = dbquery("SELECT weblink_cat_name FROM " . DB_WEBLINK_CATS . " WHERE weblink_cat_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'categories/weblinks/' . $title . '/' . $id . '.html';
}

function newsCategories ($id, $comments = "")
{
	$result = dbquery("SELECT news_cat_name FROM " . DB_NEWS_CATS . " WHERE news_cat_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'categories/news/' . $title . '/' . $id . $comments . '.html';
}

function articlesCategories ($id)
{
	$result = dbquery("SELECT article_cat_name FROM " . DB_ARTICLE_CATS . " WHERE article_cat_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'categories/articles/' . $title . '/' . $id . '.html';
}

function downloadsCategories ($id)
{
	$result = dbquery("SELECT download_cat_name FROM " . DB_DOWNLOAD_CATS . " WHERE download_cat_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'categories/downloads/' . $title . '/' . $id . '.html';
}

function profile ($id)
{
	$result = dbquery("SELECT user_name FROM " . DB_USERS . " WHERE user_id = " . $id);
	$user_name = slug(dbresult($result, 0));

	return 'profile/' . $user_name . '/' . $id . '.html';
}

function printNews ($id)
{
	$result = dbquery("SELECT news_subject FROM " . DB_NEWS . " WHERE news_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'print/news/' . $title . '/' . $id . '.html';
}

function printArticle ($id)
{
	$result = dbquery("SELECT article_subject FROM " . DB_NEWS . " WHERE article_id = " . $id);
	$title = slug(dbresult($result, 0));

	return 'print/article/' . $title . '/' . $id . '.html';
}

main();
?>